module STATE where

import ErrM

newtype STATE s a = STATE (s -> Err (a,s))

instance  Monad (STATE s) where
  return a    = STATE (\s -> return (a,s))
  STATE c >>= f = STATE (\s -> do 
                        (x,s') <- c s
                        let STATE f' = f x
                        f' s')

appSTATE :: STATE s a -> s -> Err (a,s)
appSTATE (STATE f) s = f s

stateR :: (s -> (a,s)) -> STATE s a
stateR f = STATE (\s -> return (f s))

readSTATE :: STATE s s
readSTATE = stateR (\s -> (s,s))

updateSTATE :: (s -> s) -> STATE s () 
updateSTATE f = stateR (\s -> ((),f s))

writeSTATE :: s -> STATE s ()
writeSTATE s = stateR (const ((),s))

--raise :: String -> STATE a
raise msg = STATE (\s -> Bad msg)

testSTATE :: Bool -> String -> STATE s ()
testSTATE cond msg = if cond then return () else raise msg
